Scriptname ImWaMCMScript extends SKI_ConfigBase

ImWaMaintenance Property ImWaInitQuest  Auto

GlobalVariable Property ImWaWardMagnitudeMultGV Auto
GlobalVariable Property ImWaWardCostMultGV Auto
GlobalVariable Property ImWaChargeRateGV Auto
GlobalVariable Property ImWaWardAbsorbPerkGV Auto
GlobalVariable Property ImWaWardBlocksWeaponsToggleGV Auto
GlobalVariable Property ImWaArrowsDmgReductionGV Auto
GlobalVariable Property ImWameleeWardpowerDamageMultGV Auto
GlobalVariable Property ImWarangedWardpowerDamageMultGV Auto
GlobalVariable Property ImWaVoiceBreaksWardsToggleGV Auto
GlobalVariable Property ImWaShoutWardpowerDamageGV Auto
globalVariable Property ImWaShoutsOnWardsAltMethodGV Auto
GlobalVariable Property ImWaUnlockSurroundingMasterWardGV Auto
GlobalVariable Property ImWaSurroundingMasterWardMeleeProtectionGV Auto
GlobalVariable Property ImWaUnlockReflectiveMasterWardGV Auto
GlobalVariable Property ImWaReflectiveMasterWardAutoAimGV Auto
globalVariable Property ImWaReflectiveMasterWardExcludeShoutsGV Auto



Perk Property wardAbsorb Auto
Perk Property ImWaArrowsDamageRedutionPlayerPerk Auto
Perk Property ImWaCostMultPerk Auto
Perk Property ImWaMasterWardDamageRedutionPerk Auto

float wardMagnitudeMult
float wardCostMult
float wardCharge
float absorbPerk
bool blockToggleState
float arrowsDamageMult
float meleeWPmult
float rangeWPMult
bool voiceToggleState
float shoutDamage
bool shoutsOnWardsAltMethod
bool unlockSurrounding
float surroundingWardProtection
bool unlockReflective
bool reflectiveWardAutoAim
bool reflectiveWardExcludeShouts


int magnitudeOption
int costOption
int chargeOption
int absorbPerkOption
int blockOption
int arrowsDamageOption
int meleeWPOption
int rangeWPOption
int voiceOption
int shoutDamageOption
int shoutsOnWardsAltMethodOption
int unlockSurroundingOption
int surroundingWardProtectionOption
int unlockReflectiveOption
int reflectiveWardAutoAimOption
int reflectiveWardExcludeShoutsOption

int flag1
int flag2
int flag3
int flag4
int flag5


Event OnConfigInit()
	Pages = new string[1]
	Pages[0] = "Settings"
	
	wardMagnitudeMult = ImWaWardMagnitudeMultGV.GetValue()
	wardCostMult = ImWaWardCostMultGV.GetValue()
	wardCharge = Game.GetGameSettingFloat("fMagicWardPowerMaxBase")
	absorbPerk = ImWaWardAbsorbPerkGV.GetValue() * 100.0
	blockToggleState = ImWaWardBlocksWeaponsToggleGV.GetValue() == 1.0
	arrowsDamageMult = ImWaArrowsDmgReductionGV.GetValue()
	meleeWPmult = ImWameleeWardpowerDamageMultGV.GetValue()
	rangeWPMult = ImWarangedWardpowerDamageMultGV.GetValue()
	voiceToggleState = ImWaVoiceBreaksWardsToggleGV.GetValue() == 1.0
	shoutDamage = ImWaShoutWardpowerDamageGV.GetValue()
	shoutsOnWardsAltMethod = ImWaShoutsOnWardsAltMethodGV.GetValue() == 1.0
	unlockSurrounding = ImWaUnlockSurroundingMasterWardGV.GetValue() == 0.0
	surroundingWardProtection = ImWaSurroundingMasterWardMeleeProtectionGV.GetValue()
	unlockReflective = ImWaUnlockReflectiveMasterWardGV.GetValue() == 0.0
	reflectiveWardAutoAim = ImWaReflectiveMasterWardAutoAimGV.GetValue() == 1.0
	reflectiveWardExcludeShouts = ImWaReflectiveMasterWardExcludeShoutsGV.GetValue() == 1.0
EndEvent


Event OnPageReset(string currentPage)

	If (currentPage == "")
		LoadCustomContent("WardsFunctionalitiesExtended/MCMCover.dds", 80, -80)
		return
	Else
		UnloadCustomContent()
	EndIf

	If (currentPage == "Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		
		AddHeaderOption("Magnitude, cost and charging rate")
		magnitudeOption = AddSliderOption("Wards magnitude", wardMagnitudeMult, "Mult: {2}")
		costOption = AddSliderOption("Wards cost", wardCostMult, "Mult: {2}")
		chargeOption = AddSliderOption("Wards charging", wardCharge, "Rate: {1}")
		If wardAbsorb.GetNumEntries() == 1 
			flag5 = OPTION_FLAG_NONE
		Else
			flag5 = OPTION_FLAG_DISABLED
		EndIf
		absorbPerkOption = AddSliderOption("Ward Absorb Perk", absorbPerk, "{0}%", flag5)
		AddEmptyOption()
		
		AddHeaderOption("Wards and weapons interaction")
		blockOption = AddToggleOption("Wards block weapons", blockToggleState)
		arrowsDamageOption = AddSliderOption("Arrows damage reduction", arrowsDamageMult, "Mult: {2}")
		If blockToggleState
			flag1 = OPTION_FLAG_NONE
		Else
			flag1 = OPTION_FLAG_DISABLED
		EndIf
		meleeWPOption = AddSliderOption("Melee wardpower damage", meleeWPmult, "Mult: {1}", flag1)
		rangeWPOption = AddSliderOption("Arrows wardpower damage", rangeWPMult, "Mult: {1}", flag1)
		AddEmptyOption()
		
		AddHeaderOption("Shout options")
		voiceOption = AddToggleOption("Shouts break wards", voiceToggleState)
		If voiceToggleState
			flag2 = OPTION_FLAG_NONE
		Else
			flag2 = OPTION_FLAG_DISABLED
		EndIf
		shoutDamageOption = AddSliderOption("Shouts wardpower damage", shoutDamage, "Points: {0}", flag2)
		shoutsOnWardsAltMethodOption = AddToggleOption("Alternative method", shoutsOnWardsAltMethod, flag2)
		AddEmptyOption()
		
		AddHeaderOption("Master wards options")
		unlockSurroundingOption = AddToggleOption("Surrounding master ward", unlockSurrounding)
		If unlockSurrounding && blockToggleState
			flag3 = OPTION_FLAG_NONE
		Else
			flag3 = OPTION_FLAG_DISABLED
		EndIf
		surroundingWardProtectionOption = AddSliderOption("Melee damage reduction", surroundingWardProtection, "{0}%", flag3)
		unlockReflectiveOption = AddToggleOption("Reflective master ward", unlockReflective)
		If unlockReflective
			flag4 = OPTION_FLAG_NONE
		Else
			flag4 = OPTION_FLAG_DISABLED
		EndIf
		reflectiveWardAutoAimOption = AddToggleOption("Return to sender", reflectiveWardAutoAim, flag4)
		reflectiveWardExcludeShoutsOption = AddToggleOption("Exclude shouts", reflectiveWardExcludeShouts, flag4)
	EndIf
EndEvent


Event OnOptionSelect(int optionSelected)

	If optionSelected == blockOption
		blockToggleState = !blockToggleState
		SetToggleOptionValue(optionSelected, blockToggleState)
		If blockToggleState
			ImWaWardBlocksWeaponsToggleGV.SetValue(1)
			SetOptionFlags(meleeWPOption, OPTION_FLAG_NONE)
			SetOptionFlags(rangeWPOption, OPTION_FLAG_NONE)
		Else
			ImWaWardBlocksWeaponsToggleGV.SetValue(0)
			SetOptionFlags(meleeWPOption, OPTION_FLAG_DISABLED)
			SetOptionFlags(rangeWPOption, OPTION_FLAG_DISABLED)
		EndIf
		If blockToggleState && unlockSurrounding
			SetOptionFlags(surroundingWardProtectionOption, OPTION_FLAG_NONE)
		Else
			SetOptionFlags(surroundingWardProtectionOption, OPTION_FLAG_DISABLED)
		EndIf
		
	ElseIf optionSelected == voiceOption
		voiceToggleState = !voiceToggleState
		SetToggleOptionValue(optionSelected, voiceToggleState)
		If voiceToggleState
			ImWaVoiceBreaksWardsToggleGV.SetValue(1.0)
			SetOptionFlags(shoutDamageOption, OPTION_FLAG_NONE)
			SetOptionFlags(shoutsOnWardsAltMethodOption, OPTION_FLAG_NONE)
		Else
			ImWaVoiceBreaksWardsToggleGV.SetValue(0.0)
			SetOptionFlags(shoutDamageOption, OPTION_FLAG_DISABLED)
			SetOptionFlags(shoutsOnWardsAltMethodOption, OPTION_FLAG_DISABLED)
		EndIf
		
	ElseIf optionSelected == shoutsOnWardsAltMethodOption
		shoutsOnWardsAltMethod = !shoutsOnWardsAltMethod
		SetToggleOptionValue(optionSelected, shoutsOnWardsAltMethod)
		If shoutsOnWardsAltMethod
			ImWaShoutsOnWardsAltMethodGV.SetValue(1.0)
		Else
			ImWaShoutsOnWardsAltMethodGV.SetValue(0.0)
		EndIf
	
	ElseIf optionSelected == unlockSurroundingOption
		unlockSurrounding = !unlockSurrounding
		SetToggleOptionValue(optionSelected, unlockSurrounding)
		If unlockSurrounding
			ImWaUnlockSurroundingMasterWardGV.SetValue(100.0)
		Else
			ImWaUnlockSurroundingMasterWardGV.SetValue(0.0)
		EndIf
		If unlockSurrounding && blockToggleState
			SetOptionFlags(surroundingWardProtectionOption, OPTION_FLAG_NONE)
		Else
			SetOptionFlags(surroundingWardProtectionOption, OPTION_FLAG_DISABLED)
		EndIf
	
	ElseIf optionSelected == unlockReflectiveOption
		unlockReflective = !unlockReflective
		SetToggleOptionValue(optionSelected, unlockReflective)
		If unlockReflective
			ImWaUnlockReflectiveMasterWardGV.SetValue(100.0)
			SetOptionFlags(reflectiveWardAutoAimOption, OPTION_FLAG_NONE)
			SetOptionFlags(reflectiveWardExcludeShoutsOption, OPTION_FLAG_NONE)
		Else
			ImWaUnlockReflectiveMasterWardGV.SetValue(0.0)
			SetOptionFlags(reflectiveWardAutoAimOption, OPTION_FLAG_DISABLED)
			SetOptionFlags(reflectiveWardExcludeShoutsOption, OPTION_FLAG_DISABLED)
		EndIf
	
	ElseIf optionSelected == reflectiveWardAutoAimOption
		reflectiveWardAutoAim = !reflectiveWardAutoAim
		SetToggleOptionValue(optionSelected, reflectiveWardAutoAim)
		If reflectiveWardAutoAim
			ImWaReflectiveMasterWardAutoAimGV.SetValue(1.0)
		Else
			ImWaReflectiveMasterWardAutoAimGV.SetValue(0.0)
		EndIf
		
	ElseIf optionSelected == reflectiveWardExcludeShoutsOption
		reflectiveWardExcludeShouts = !reflectiveWardExcludeShouts
		SetToggleOptionValue(optionSelected, reflectiveWardExcludeShouts)
		If reflectiveWardExcludeShouts
			ImWaReflectiveMasterWardExcludeShoutsGV.SetValue(1.0)
		Else
			ImWaReflectiveMasterWardExcludeShoutsGV.SetValue(0.0)
		EndIf
	EndIf
	
EndEvent


Event OnOptionSliderOpen(int optionSelected)

	If (optionSelected == magnitudeOption)
		SetSliderDialogStartValue(wardMagnitudeMult)
		SetSliderDialogDefaultValue(1.5)
		SetSliderDialogRange(0.1, 5)
		SetSliderDialogInterval(0.1)
	ElseIf (optionSelected == costOption)
		SetSliderDialogStartValue(wardCostMult)
		SetSliderDialogDefaultValue(0.5)
		SetSliderDialogRange(0.1, 5)
		SetSliderDialogInterval(0.1)
	ElseIf (optionSelected == chargeOption)
		SetSliderDialogStartValue(wardCharge)
		SetSliderDialogDefaultValue(0.5)
		SetSliderDialogRange(0.1, 5)
		SetSliderDialogInterval(0.1)
	ElseIf (optionSelected == absorbPerkOption)
		SetSliderDialogStartValue(absorbPerk)
		SetSliderDialogDefaultValue(50)
		SetSliderDialogRange(0, 100)
		SetSliderDialogInterval(1)
	ElseIf (optionSelected == arrowsDamageOption)
		SetSliderDialogStartValue(arrowsDamageMult)
		SetSliderDialogDefaultValue(0.5)
		SetSliderDialogRange(0, 1)
		SetSliderDialogInterval(0.1)
	ElseIf (optionSelected == meleeWPOption)
		SetSliderDialogStartValue(meleeWPmult)
		SetSliderDialogDefaultValue(1.5)
		SetSliderDialogRange(0, 5)
		SetSliderDialogInterval(0.1)
	ElseIf (optionSelected == rangeWPOption)
		SetSliderDialogStartValue(rangeWPMult)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(0, 5)
		SetSliderDialogInterval(0.1)
	ElseIf (optionSelected == shoutDamageOption)
		SetSliderDialogStartValue(shoutDamage)
		SetSliderDialogDefaultValue(140)
		SetSliderDialogRange(0, 250)
		SetSliderDialogInterval(10)
	ElseIf (optionSelected == surroundingWardProtectionOption)
		SetSliderDialogStartValue(surroundingWardProtection)
		SetSliderDialogDefaultValue(85)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	EndIf
	
EndEvent


Event OnOptionSliderAccept(int optionSelected, float newValue)

	If (optionSelected == magnitudeOption)
		wardMagnitudeMult = newValue
		SetSliderOptionValue(magnitudeOption, wardMagnitudeMult, "Mult: {1}")
		ImWaWardMagnitudeMultGV.SetValue(wardMagnitudeMult)
		ImWaInitQuest.MagnitudeUpdate()

	ElseIf (optionSelected == costOption)
		wardCostMult = newValue
		SetSliderOptionValue(costOption, wardCostMult, "Mult: {1}")
		ImWaCostMultPerk.SetNthEntryValue(0, 0, wardCostMult)
		ImWaWardCostMultGV.SetValue(wardCostMult)
		
	ElseIf (optionSelected == chargeOption)
		wardCharge = newValue
		SetSliderOptionValue(chargeOption, wardCharge, "Rate: {1}")
		Game.SetGameSettingFloat("fMagicWardPowerMaxBase", wardCharge)
		ImWaChargeRateGV.SetValue(wardCharge)
		
	ElseIf (optionSelected == absorbPerkOption)
		absorbPerk = newValue
		SetSliderOptionValue(absorbPerkOption, absorbPerk, "{0}%")
		wardAbsorb.SetNthEntryValue(0, 0, absorbPerk/100.0)
		ImWaWardAbsorbPerkGV.SetValue(absorbPerk/100.0)
		
	ElseIf (optionSelected == arrowsDamageOption)
		arrowsDamageMult = newValue
		SetSliderOptionValue(arrowsDamageOption, arrowsDamageMult, "Mult: {1}")
		ImWaArrowsDamageRedutionPlayerPerk.SetNthEntryValue(0, 0, arrowsDamageMult)
		ImWaArrowsDmgReductionGV.SetValue(arrowsDamageMult)
	
	ElseIf (optionSelected == meleeWPOption)
		meleeWPmult = newValue
		SetSliderOptionValue(meleeWPOption, meleeWPmult, "Mult: {1}")
		ImWameleeWardpowerDamageMultGV.SetValue(meleeWPmult)
	
	ElseIf (optionSelected == rangeWPOption)
		rangeWPMult = newValue
		SetSliderOptionValue(rangeWPOption, rangeWPMult, "Mult: {1}")
		ImWarangedWardpowerDamageMultGV.SetValue(rangeWPMult)
		
	ElseIf (optionSelected == shoutDamageOption)
		shoutDamage = newValue
		SetSliderOptionValue(shoutDamageOption, shoutDamage, "Points: {0}")
		ImWaShoutWardpowerDamageGV.SetValue(shoutDamage)
	
	ElseIf (optionSelected == surroundingWardProtectionOption)
		surroundingWardProtection = newValue
		SetSliderOptionValue(surroundingWardProtectionOption, surroundingWardProtection, "{0}%")
		ImWaSurroundingMasterWardMeleeProtectionGV.SetValue(surroundingWardProtection)
		ImWaMasterWardDamageRedutionPerk.SetNthEntryValue(0, 0, 1.0 - (ImWaSurroundingMasterWardMeleeProtectionGV.GetValue() / 100.0 ))
	EndIf
	
EndEvent


Event OnOptionHighlight(int selectedOption)

	If (selectedOption == magnitudeOption)
		SetInfoText("Multiplier for wards magnitude. Vanilla:1 Mod default:1.5")
	ElseIf (selectedOption == costOption)
		SetInfoText("Multiplier for wards spell cost. Only works for the player. Vanilla:1 Mod default:0.5")
	ElseIf (selectedOption == chargeOption)
		SetInfoText("Ward charge/recharge rate. Vanilla:1.3 Mod default:0.5")
	ElseIf (selectedOption == absorbPerkOption && flag5 == OPTION_FLAG_NONE)
		SetInfoText("Magicka absorption percentage with the Ward Absorb perk. Vanilla:25% Mod default:50%")
	ElseIf (selectedOption == absorbPerkOption && flag5 == OPTION_FLAG_DISABLED)
		SetInfoText("Option Deactivated, another mod is changing the Ward Absorb perk.")
	ElseIf (selectedOption == blockOption)
		SetInfoText("If on, casting a ward counts as blocking. Health damage is calculated the same way than blocking with a weapon.")
	ElseIf (selectedOption == arrowsDamageOption)
		SetInfoText("Damage reduction when hit with an arrows/bolt passing through a ward. Only works for the player.")
	ElseIf (selectedOption == meleeWPOption)
		SetInfoText("Multiplier for how much a melee weapon damages the ward itself.")
	ElseIf (selectedOption == rangeWPOption)
		SetInfoText("Multiplier for how much an arrow/bolt damages the ward itself.")
	ElseIf (selectedOption == voiceOption)
		SetInfoText("If on, shouts inflict damage to wards, and if broken, the caster is affected by the shout.")
	ElseIf (selectedOption == shoutDamageOption)
		SetInfoText("Amount of damage a shout does to a ward.")
	ElseIf (selectedOption == shoutsOnWardsAltMethodOption)
		SetInfoText("If checked, an alternative method will be used to make shouts pass through wards. It will take modifications to vanilla shouts into account and fully work with mod added shouts but may cause unwanted audio and visual effects. If unchecked, modification to vanilla shouts will be ignored and mod added shouts will just break the ward and stagger its caster.")
	ElseIf (selectedOption == unlockSurroundingOption)
		SetInfoText("If checked, Surrounding Master Ward will be sold by Colette Marence once the \"Restoration Ritual Spell\" quest is completed, like other master restoration spells. If unchecked, the spell will not be available ingame.")
	ElseIf (selectedOption == surroundingWardProtectionOption)
		SetInfoText("Percentage of melee damage reduction with the Surrounding Master Ward (blocking formulas do not apply for this spell). Arrows damage reduction still depends on the \"Arrows damage reduction\" slider above.")
	ElseIf (selectedOption == unlockReflectiveOption)
		SetInfoText("If checked, Reflective Master Ward will be sold by Colette Marence once the \"Restoration Ritual Spell\" quest is completed, like other master restoration spells. If unchecked, the spell will not be available ingame.")
	ElseIf (selectedOption == reflectiveWardAutoAimOption)
		SetInfoText("If checked, the Reflective Master Ward will aim the reflected spells at the caster. If unchecked, the spell will be aimed with the crosshair.")
	ElseIf (selectedOption == reflectiveWardExcludeShoutsOption)
		SetInfoText("If checked, the Reflective Master Ward will not reflect shouts.")
	EndIf
	
EndEvent
