Scriptname ImWaWardReflectionScript extends activemagiceffect  

globalVariable Property ImWaReflectiveMasterWardAutoAimGV Auto
globalVariable Property ImWaReflectiveMasterWardExcludeShoutsGV Auto

FormList Property ImWaExcludedShoutsFormList Auto

Activator Property FxEmptyActivator Auto

spell Property ImWaVoiceUnrelentingForce1 Auto

bool Property debugVerbosity Auto

actor wardCasterActor ;actor casting the ward
bool autoAim
bool excludeShots
bool onWardHitFunctionBusy = False

float Property wardDistance = 50.0 Auto
float Property targetDistanceMult = 2.0 Auto
float Property castingHeightDifference = 15.0 Auto

Event OnEffectStart(actor akTarget, actor akCaster)
	wardCasterActor = akCaster
	autoAim = ImWaReflectiveMasterWardAutoAimGV.GetValue() == 1.0
	excludeShots = ImWaReflectiveMasterWardExcludeShoutsGV.GetValue() == 1.0
	GotoState("WardCanBeHit")
EndEvent


State WardCanBeHit
	Event OnWardHit(ObjectReference akCaster, Spell akSpell, int aiStatus)
		Debug.TraceConditional(self + "reflective ward hit event at time:" + Utility.GetCurrentRealTime(), debugVerbosity)
		If !onWardHitFunctionBusy && aiStatus != 2 &&  akSpell && !ImWaExcludedShoutsFormList.HasForm(akSpell)
			onWardHitFunctionBusy = True 
			If !excludeShots || akSpell.GetEquipType() != ImWaVoiceUnrelentingForce1.GetEquipType()
				ObjectReference target
				float zAngle = wardCasterActor.GetAngleZ()
				float xPosition = Math.Sin(zAngle) * wardDistance
				float yPosition = Math.Cos(zAngle) * wardDistance
				float zOffset = wardCasterActor.GetHeight() - castingHeightDifference
				float zPosition = Math.Sin(wardCasterActor.GetAngleX()) * -wardDistance
				If autoAim
					target = akCaster
				Else
					target = wardCasterActor.PlaceAtMe(FxEmptyActivator)
					target.MoveTo(wardCasterActor, targetDistanceMult * xPosition, targetDistanceMult * yPosition, targetDistanceMult * zPosition + zOffset)
				EndIf
				ObjectReference castingObjectRef = wardCasterActor.PlaceAtMe(FxEmptyActivator)
				;moves the casting object 30 unites in front of the ward caster, 15 unites below its height and match orientation angle
				castingObjectRef.MoveTo(wardCasterActor, xPosition, yPosition, zOffset)
				akSpell.Cast(castingObjectRef, target)
				Debug.TraceConditional(self + "Spell:" + akSpell + " reflected aimed at:" + target + " at time:" + Utility.GetCurrentRealTime(), debugVerbosity)
				Utility.Wait(0.3)
				castingObjectRef.InterruptCast()
				Utility.Wait(0.3)
				castingObjectRef.Delete()
				If !autoAim
					target.Delete()
				EndIf
			EndIf
		EndIf
		onWardHitFunctionBusy = False
	EndEvent
EndState
