Scriptname ImWaStrangeRunesPatchScript extends ReferenceAlias

MagicEffect Property ImWaWardConcSelf75 Auto
MagicEffect Property ImWaWardConcSelf100Reflective Auto
MagicEffect Property ImWaShieldSelfReflective Auto
MagicEffect Property ImWaWardSelf100 Auto
MagicEffect Property ImWaWardSelf100R Auto
MagicEffect Property ImWaWardSelf100L Auto
MagicEffect Property ImWaWardSelf100B Auto

MagicEffect Property po3_RUNE_WardDefaultRune Auto
MagicEffect Property po3_RUNE_WardDefaultRuneR Auto
MagicEffect Property po3_RUNE_WardDefaultRuneL Auto
MagicEffect Property po3_RUNE_WardDefaultRuneB Auto

MagicEffect Property po3_RUNE_WardStrangeRune Auto
MagicEffect Property po3_RUNE_WardStrangeRuneR Auto
MagicEffect Property po3_RUNE_WardStrangeRuneL Auto
MagicEffect Property po3_RUNE_WardStrangeRuneB Auto

MagicEffect Property po3_RUNE_WardVanillaRune Auto
MagicEffect Property po3_RUNE_WardVanillaRuneR Auto
MagicEffect Property po3_RUNE_WardVanillaRuneL Auto
MagicEffect Property po3_RUNE_WardVanillaRuneB Auto

Light Property MagicLightFireInHand Auto
Light Property MagicLightWardHand01 Auto

GlobalVariable Property po3_RUNE_WardType Auto

Art VanillaRune
Art VanillaRuneCastingArt
Art DefaultRune
Art StrangeRune
Art StrangeRuneCastingArt


Event OnInit()
	UpdateWards()
EndEvent


Event OnPlayerLoadGame()
	UpdateWards()
EndEvent


Function UpdateWards()
	StrangeRune = po3_RUNE_WardStrangeRune.GetHitEffectArt()
	DefaultRune = po3_RUNE_WardDefaultRune.GetHitEffectArt()
	VanillaRune = po3_RUNE_WardVanillaRune.GetHitEffectArt()
	
	StrangeRuneCastingArt = po3_RUNE_WardStrangeRune.GetCastingArt()
	VanillaRuneCastingArt = po3_RUNE_WardVanillaRune.GetCastingArt()
	
	If po3_RUNE_WardType.GetValue() == 0.0
		SetWardSpellArt(VanillaRune, VanillaRuneCastingArt, MagicLightWardHand01, 1)
	elseif po3_RUNE_WardType.GetValue() == 1.0
		SetWardSpellArt(DefaultRune, VanillaRuneCastingArt, MagicLightWardHand01, 0)
	elseif po3_RUNE_WardType.GetValue() == 2.0
		SetWardSpellArt(StrangeRune, StrangeRuneCastingArt, MagicLightFireInHand, 0)
	endif
EndFunction


Function SetWardSpellArt(Art WardHitArt, Art WardCastArt, Light WardLight, int VanillaState)
	ImWaWardConcSelf75.SetCastingArt(WardCastArt)
	ImWaWardConcSelf100Reflective.SetCastingArt(WardCastArt)
	ImWaShieldSelfReflective.SetCastingArt(WardCastArt)
	ImWaWardSelf100.SetCastingArt(WardCastArt)
	
	ImWaWardConcSelf75.SetHitEffectArt(WardHitArt)
	ImWaWardConcSelf100Reflective.SetHitEffectArt(WardHitArt)
	ImWaShieldSelfReflective.SetHitEffectArt(WardHitArt)
	ImWaWardSelf100.SetHitEffectArt(WardHitArt)
	
	If po3_RUNE_WardType.GetValue() == 1.0
		ImWaWardSelf100R.SetHitEffectArt(po3_RUNE_WardDefaultRuneR.GetHitEffectArt())
		ImWaWardSelf100L.SetHitEffectArt(po3_RUNE_WardDefaultRuneL.GetHitEffectArt())
		ImWaWardSelf100B.SetHitEffectArt(po3_RUNE_WardDefaultRuneB.GetHitEffectArt())
	ElseIf po3_RUNE_WardType.GetValue() == 2.0
		ImWaWardSelf100R.SetHitEffectArt(po3_RUNE_WardStrangeRuneR.GetHitEffectArt())
		ImWaWardSelf100L.SetHitEffectArt(po3_RUNE_WardStrangeRuneL.GetHitEffectArt())
		ImWaWardSelf100B.SetHitEffectArt(po3_RUNE_WardStrangeRuneB.GetHitEffectArt())
	Else
		ImWaWardSelf100R.SetHitEffectArt(po3_RUNE_WardVanillaRuneR.GetHitEffectArt())
		ImWaWardSelf100L.SetHitEffectArt(po3_RUNE_WardVanillaRuneL.GetHitEffectArt())
		ImWaWardSelf100B.SetHitEffectArt(po3_RUNE_WardVanillaRuneB.GetHitEffectArt())
	EndIf
	
	ImWaWardConcSelf75.SetLight(WardLight)
	ImWaWardConcSelf100Reflective.SetLight(WardLight)
	ImWaShieldSelfReflective.SetLight(WardLight)
	ImWaWardSelf100.SetLight(WardLight)
EndFunction