Scriptname PO3_RUNEMCMenu extends ski_configbase 

;======================================================================================;
;  PROPERTIES  /
;=============/

import po3_SKSEFunctions

;OID's
int OID_AllowNPCCast
int OID_AllowStats
int OID_NPCCount
int OID_StatsDisabled
int OID_NPCList
int OID_DisableNotifications

int OID_AllowPCFF
int OID_AllowPCConc
int OID_AllowPCScrolls
int OID_AllowNPCFF
int OID_AllowNPCConc
int OID_AllowMaster

int OID_Patch
int OID_NPCPatch

int OID_RefreshAliasesKey

int OID_ClearSpells

int OID_WardTypeVanilla
int OID_WardTypeDefault
int OID_WardTypeStrange

int OID_WardPatch

int OID_ResetQuest

int OID_SetLightRadius
int OID_SetLightFade
int OID_SetWardLightRadius
int OID_SetWardLightFade
int OID_SetRitualLightRadius
int OID_SetRitualLightFade
int OID_ENBLightPatch

int OID_EnableRuneShadowCasting
int OID_EnableWardShadowCasting
int OID_EnableRitualShadowCasting

int OID_AllowSneakingLights

;Toggle states
bool aVal = true ;NPC toggle

bool bVal = true
bool cVal = true
bool hVal = true
bool iVal = true

bool dVal = true
bool eVal = true

bool fVal = false
bool gVal = false
;ward
bool jVal = false
bool kVal = true
bool lVal = false

bool mVal = false

bool nVal = false

bool oVal = false

bool pVal = true

;shadows
bool qVal = false
bool rVal = false

;sneak
bool sVal = false

bool tVal = false

; slider defaults
int default_rMinValue = 16
int default_rMaxValue = 2048
int default_rInterval = 8

float default_fMinValue = 0.0
float default_fMaxValue = 10.0
float default_fInterval = 0.10

;Globals

GlobalVariable Property po3_RUNE_AllowNPCCasting Auto
GlobalVariable Property po3_RUNE_AllowPCFFSpells Auto
GlobalVariable Property po3_RUNE_AllowPCSelfSpells Auto
GlobalVariable Property po3_RUNE_AllowPCConcSpells Auto
GlobalVariable Property po3_RUNE_AllowPCScrolls Auto
GlobalVariable Property po3_RUNE_AllowNPCFFSpells Auto
GlobalVariable Property po3_RUNE_AllowNPCSelfSpells Auto
GlobalVariable Property po3_RUNE_AllowNPCConcSpells Auto
GlobalVariable Property po3_RUNE_AllowMasterSpells Auto
GlobalVariable Property po3_RUNE_AllowRuneShadows Auto
GlobalVariable Property po3_RUNE_AllowWardShadows Auto
GlobalVariable Property po3_RUNE_AllowRitualShadows Auto

GlobalVariable Property po3_RUNE_AllowMagAnimPatch Auto
GlobalVariable Property po3_RUNE_AllowNPCMagAnimPatch Auto
GlobalVariable Property po3_RUNE_AllowModdedWards Auto
GlobalVariable Property po3_RUNE_AllowENBLights Auto
GlobalVariable Property po3_RUNE_AllowSneakingLights Auto
GlobalVariable Property po3_RUNE_AllowStats Auto

GlobalVariable Property po3_RUNE_LightRadius Auto
GlobalVariable Property po3_RUNE_LightFade Auto
GlobalVariable Property po3_RUNE_WardLightRadius Auto
GlobalVariable Property po3_RUNE_WardLightFade Auto
GlobalVariable Property po3_RUNE_RitualLightRadius Auto
GlobalVariable Property po3_RUNE_RitualLightFade Auto

GlobalVariable Property po3_RUNE_WardType Auto

GlobalVariable Property po3_RUNE_RefreshAliasesKey Auto
GlobalVariable Property po3_RUNE_DisableNotifications Auto
GlobalVariable Property po3_RUNE_NPCCount Auto 

;Quest
Quest Property po3_RUNE_NPCAliasesQuest Auto
Quest Property po3_RUNE_PlayerQuest Auto

;int
int npcCount
int npcIndex = 0

float OID_LightRadius = 176.0
float OID_WardLightRadius = 300.0
float OID_RitualLightRadius = 300.0
float OID_LightFade = 1.50
float OID_WardLightFade = 1.50
float OID_RitualLightFade = 1.50

;array
Spell[] Property SpellArray Auto

String[] npcNames
String[] Property npcTempNames Auto
string npcName

;mgeffect
MagicEffect Property po3_RUNE_WardVanillaRune Auto
MagicEffect Property po3_RUNE_WardDefaultRune Auto
MagicEffect Property po3_RUNE_WardStrangeRune Auto

MagicEffect Property WardConcSelf0 Auto
MagicEffect Property WardConcSelf25 Auto
MagicEffect Property WardConcSelf50 Auto
MagicEffect Property ShieldConcSelf Auto

;----------added for Wards Functionalities Extended patch----------
MagicEffect Property ImWaWardConcSelf75 Auto
MagicEffect Property ImWaWardConcSelf100Reflective Auto
MagicEffect Property ImWaShieldSelfReflective Auto
MagicEffect Property ImWaWardSelf100 Auto
MagicEffect Property ImWaWardSelf100R Auto
MagicEffect Property ImWaWardSelf100L Auto
MagicEffect Property ImWaWardSelf100B Auto

MagicEffect Property po3_RUNE_WardDefaultRuneR Auto
MagicEffect Property po3_RUNE_WardDefaultRuneL Auto
MagicEffect Property po3_RUNE_WardDefaultRuneB Auto

MagicEffect Property po3_RUNE_WardStrangeRuneR Auto
MagicEffect Property po3_RUNE_WardStrangeRuneL Auto
MagicEffect Property po3_RUNE_WardStrangeRuneB Auto

MagicEffect Property po3_RUNE_WardVanillaRuneR Auto
MagicEffect Property po3_RUNE_WardVanillaRuneL Auto
MagicEffect Property po3_RUNE_WardVanillaRuneB Auto
;--------------------------------------------------------------------

;kywd
Keyword Property MagicWard Auto

;art 
Art VanillaRune
Art VanillaRuneCastingArt
Art DefaultRune
Art StrangeRune
Art StrangeRuneCastingArt

Actor Property PlayerRef Auto

;light
Light Property MagicLightFireInHand Auto
Light Property MagicLightWardHand01 Auto

Light[] Property runeLights Auto
Light[] Property runeWardLights Auto
Light[] Property runeRitualLights Auto

;formlist
Formlist Property po3_RUNE_WardsFormlist Auto

;spells
Spell Property po3_RUNE_DetectCastAbility Auto

; ---------------------------------SCRIPT VERSION ---------------------------

int function GetVersion()

	return 1 ; Default version

endFunction

;======================================================================================;
;  EVENTS  /
;=============/

event OnInit()

	parent.OnInit()
	
endEvent

;-------------------EVENT ONCONFIGINIT()----------------------------------

Event OnConfigInit()

	Pages = new string[4]
	Pages[0] = "Misc Settings"	
	Pages[1] = "Light Settings"
	Pages[2] = "Rune Settings"
	Pages[3] = "Stats"	
	
	StrangeRune = po3_RUNE_WardStrangeRune.GetHitEffectArt()
	DefaultRune = po3_RUNE_WardDefaultRune.GetHitEffectArt()
	VanillaRune = po3_RUNE_WardVanillaRune.GetHitEffectArt()
	
	StrangeRuneCastingArt = po3_RUNE_WardStrangeRune.GetCastingArt()
	VanillaRuneCastingArt = po3_RUNE_WardVanillaRune.GetCastingArt()

EndEvent

;-----------------EVENT ONGAMERELOAD()------------------------------

Event OnGameReload()

	Parent.OnGameReload()

	OnConfigInit()

EndEvent

;-----------------EVENT ONPAGERESET()------------------------------------------

Event OnPageReset(string page)

	if (page == "")
		LoadCustomContent("po3magicrunes/magicrunes.dds", 0.0, 0.0)
		return
	else
		UnloadCustomContent()
	endIf
	
	If (page == "Misc Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Fixes")
		OID_ResetQuest = AddTextOption("Reset mod", "")
		OID_ClearSpells = AddTextOption("Clear all VFX", "")
		AddEmptyOption()
		OID_AllowStats = AddToggleOption("Enable Statistics", nVal)
	
	ElseIf (page == "Light Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		OID_AllowSneakingLights = AddToggleOption("Enable lights when sneaking", sVal)
		AddEmptyOption()
		AddHeaderOption("Runes")
		;OID_EnableRuneShadowCasting = AddToggleOption("Enable Shadows", qVal)
		OID_SetLightRadius = AddSliderOption("Light radius", po3_RUNE_LightRadius.GetValue(), "{0} units")
		if pVal == true
			OID_SetLightFade = AddSliderOption("Light intensity", po3_RUNE_LightFade.GetValue(), "{2}")
		else
			OID_SetLightFade = AddSliderOption("Light intensity", po3_RUNE_LightFade.GetValue(), "{2}", OPTION_FLAG_DISABLED)
		endif
		AddEmptyOption()
		AddHeaderOption("Ritual Runes")
		OID_EnableRitualShadowCasting = AddToggleOption("Enable Shadows", tVal)
		OID_SetRitualLightRadius = AddSliderOption("Light radius", po3_RUNE_RitualLightRadius.GetValue(), "{0} units")
		if pVal == true
			OID_SetRitualLightFade = AddSliderOption("Light intensity", po3_RUNE_RitualLightFade.GetValue(), "{2}")
		else
			OID_SetRitualLightFade = AddSliderOption("Light intensity", po3_RUNE_RitualLightFade.GetValue(), "{2}", OPTION_FLAG_DISABLED)
		endif
		SetCursorPosition(1)
		AddEmptyOption()
		AddEmptyOption()
		AddHeaderOption("Ward Runes")
		OID_EnableWardShadowCasting = AddToggleOption("Enable Shadows", rVal)
		OID_SetWardLightRadius = AddSliderOption("Light radius", po3_RUNE_WardLightRadius.GetValue(), "{0} units")
		if pVal == true
			OID_SetWardLightFade = AddSliderOption("Light intensity", po3_RUNE_WardLightFade.GetValue(), "{2}")
		else
			OID_SetWardLightFade = AddSliderOption("Light intensity", po3_RUNE_WardLightFade.GetValue(), "{2}", OPTION_FLAG_DISABLED)
		endif

	ElseIf (page == "Rune Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Player")
		OID_Patch = AddToggleOption("Patch for magic animation mods", fVal)
		AddEmptyOption()
		OID_AllowMaster = AddToggleOption("Master ritual spells", iVal)
		OID_AllowPCFF = AddToggleOption("Fire and Forget spells", bVal)
		OID_AllowPCConc = AddToggleOption("Concentration spells", cVal)
		OID_AllowPCScrolls = AddToggleOption("Scrolls", hVal)
		AddEmptyOption()
		;OID_WardPatch = AddToggleOption("Patch for mod added ward spells", mVal)
		AddHeaderOption("Ward Type")
		If po3_RUNE_WardType.GetValue() == 0.0
			jVal = true
			OID_WardTypeVanilla = AddToggleOption("Vanilla", jVal)
			OID_WardTypeDefault = AddToggleOption("Default Rune", kVal, OPTION_FLAG_DISABLED)
			OID_WardTypeStrange = AddToggleOption("Amber Rune", lVal, OPTION_FLAG_DISABLED)
		elseif po3_RUNE_WardType.GetValue() == 1.0
			OID_WardTypeVanilla = AddToggleOption("Vanilla", jVal, OPTION_FLAG_DISABLED)
			OID_WardTypeDefault = AddToggleOption("Default Rune", kVal)
			OID_WardTypeStrange = AddToggleOption("Amber Rune", lVal, OPTION_FLAG_DISABLED)
		elseif	po3_RUNE_WardType.GetValue() == 2.0
			OID_WardTypeVanilla = AddToggleOption("Vanilla", jVal, OPTION_FLAG_DISABLED)
			OID_WardTypeDefault = AddToggleOption("Default Rune", kVal, OPTION_FLAG_DISABLED)
			OID_WardTypeStrange = AddToggleOption("Amber Rune", lVal)
		endif
		SetCursorPosition(1) 
		AddHeaderOption("NPCs")
		OID_NPCPatch = AddToggleOption("Patch for magic animation mods", gVal)
		AddEmptyOption()
		OID_AllowNPCCast = AddToggleOption("Allow NPC Casting", aVal)
		OID_RefreshAliasesKey =  AddKeyMapOption("Refresh Aliases Hotkey", po3_RUNE_RefreshAliasesKey.GetValue() as int)
		OID_DisableNotifications = AddToggleOption("Disable notifications", oVal)
		AddEmptyOption()
		OID_AllowNPCFF = AddToggleOption("Fire and Forget spells", dVal)
		OID_AllowNPCConc = AddToggleOption("Concentration spells", eVal)
		
	Elseif (page == "Wards")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		;AddEmptyOption()
	
	Elseif (page == "Stats")
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Stats")
		If po3_RUNE_AllowStats.GetValue() == 0.0
			OID_StatsDisabled = AddTextOption("Statistics not enabled!", "")
		else
			GetNPCNames()
			OID_npcCount = AddTextOption("NPCs in range", po3_RUNE_NPCCount.GetValue() as int + "/" + po3_RUNE_NPCAliasesQuest.GetNumAliases()/2)
			if (po3_RUNE_NPCCount.GetValue() as int) == 0
				OID_NPCList = AddMenuOption("NPCs", "null")
			else
				OID_NPCList = AddMenuOption("NPCs", npcNames[npcIndex])
			endif
		endif
	endif
	
endEvent
	
;----------EVENT ONOPTIONHIGLIGHT()-----------------------------------------------------

event OnOptionHighlight(int option)

	;npc casting
	If (option == OID_AllowNPCCast)
		SetInfoText("NPCs will cast runic circles when casting spells\nDefault Value = True")
	elseif (option == OID_AllowPCFF)
		SetInfoText("Enables runic circles when the player casts fire and forget spells,\nsuch as Firebolt or Fury.\nDefault Value = True")
	elseif (option == OID_AllowPCConc)
		SetInfoText("Enables runic circles when the player casts concentration spells,\nsuch as Flames or Frostbite.\nDefault Value = True")
	elseif (option == OID_AllowPCScrolls)
		SetInfoText("Enables runic circles when the player casts magic using scrolls.\nDefault Value = True")
	elseif (option == OID_AllowNPCFF)
		SetInfoText("Enables runic circles when NPCs cast fire and forget spells,\nsuch as Firebolt or Fury.\nDefault Value = True")
	elseif (option == OID_AllowNPCConc)
		SetInfoText("Enables runic circles when NPCs cast concentration spells,\nsuch as Flames or Frostbite.\nDefault Value = True")
	elseif (option == OID_Patch)
		SetInfoText("Enable if using an alternative magic animation mod.\nDO NOT enable if using vanilla 3rd person player animations.\nDefault Value = False")
	elseif (option == OID_NPCPatch)
		SetInfoText("Enable if using an alternative magic animation mod that affects NPCs.\nDO NOT enable if using vanilla 3rd person NPC animations.\nDefault Value = False")	
	ElseIf (option == OID_RefreshAliasesKey)
		SetInfoText("Changes the hotkey to refresh aliases. Useful in cases where new NPCs have entered the area. Do not spam repeatedly.")
	ElseIf (option == OID_ClearSpells)
		SetInfoText("Click to remove all runic circle FX from the player. For cases where effects did not dispel properly")
	ElseIf (option == OID_ResetQuest)
		SetInfoText("Resets the entire mod. Click this if runes are not showing up at all, and only after the MCM has been registered. You may have to do this a couple of times")
	Elseif (option == OID_AllowMaster)
		SetInfoText("Enables runic circles when the player casts master rituals spells such as Firestorm or Blizzard.\nDefault Value = True")
	;Elseif (option == OID_WardPatch)
		;SetInfoText("Enable if using mods that add new ward spells.\nDefault Value = False")
	Elseif (option == OID_WardTypeVanilla)
		SetInfoText("Reverts wards back to vanilla.")
	Elseif (option == OID_WardTypeDefault)
		SetInfoText("Aqua runic circles (vanilla ward colours).")
	Elseif (option == OID_WardTypeStrange)
		SetInfoText("Amber runic circles.")
	elseif (option == OID_AllowStats)
		SetInfoText("Shows a list of NPCs in the area that are currently being monitored by Strange Runes. List will only update as you move across cells. There may be a slight performance hit.")
	elseif (option == OID_DisableNotifications)
		SetInfoText("Disables notifications that show if you manually refresh aliases using the hotkey")	
	elseif (option == OID_ENBLightPatch)
		SetInfoText("Enable if using the optional ENB particle light patch. Light brightness is disabled when this is enabled")	
	elseif (option == OID_SetLightRadius)
		SetInfoText("Sets the light radius of normal runes, in Skyrim units.\n" + po3_RUNE_LightRadius.GetValue() as int + " units == " + Round((po3_RUNE_LightRadius.GetValue()/69.99125), 2) + " metres | " + Round((po3_RUNE_LightRadius.GetValue()/21.33333), 2) + " feet")	
	elseif (option == OID_SetWardLightRadius)
		SetInfoText("Sets the light radius of ward runes, in Skyrim units.\n" + po3_RUNE_WardLightRadius.GetValue() as int + " units == " + Round((po3_RUNE_WardLightRadius.GetValue()/69.99125), 2) + " metres | " + Round((po3_RUNE_WardLightRadius.GetValue()/21.33333), 2) + " feet")
	elseif (option == OID_SetRitualLightRadius)
		SetInfoText("Sets the light radius of ritual runes, in Skyrim units.\n" + po3_RUNE_RitualLightRadius.GetValue() as int + " units == " + Round((po3_RUNE_RitualLightRadius.GetValue()/69.99125), 2) + " metres | " + Round((po3_RUNE_RitualLightRadius.GetValue()/21.33333), 2) + " feet")
	elseif (option == OID_SetLightFade)
		SetInfoText("Sets the light intensity of normal runes. Default is 1.5")	
	elseif (option == OID_SetWardLightFade)
		SetInfoText("Sets the light intensity of ward runes. Default is 2")
	elseif (option == OID_SetRitualLightFade)
		SetInfoText("Sets the light intensity of ritual runes. Default is 2")
	elseif (option == OID_EnableRuneShadowCasting)
		SetInfoText("Enables shadowcasting for normal runes")
	elseif (option == OID_EnableWardShadowCasting)
		SetInfoText("Enables shadowcasting for ward runes")
	elseif (option == OID_EnableRitualShadowCasting)
		SetInfoText("Enables shadowcasting for ritual runes")
	elseif (option == OID_AllowSneakingLights)
		SetInfoText("Runes don't disappear when sneaking")		
	endif

endEvent

;----------EVENT ONOPTIONDEFAULT()---------------------------------------------------------

Event OnOptionDefault(int option)

	If (option == OID_RefreshAliasesKey)
	
		po3_RUNE_RefreshAliasesKey.SetValue(37 as float)
		SetKeymapOptionValue(OID_RefreshAliasesKey, po3_RUNE_RefreshAliasesKey.GetValue() as int)
		
	EndIf
	
EndEvent

;=======================================================

Event OnOptionKeyMapChange(int option, int keyCode, string conflictControl, string conflictName)
	    
    If (option == OID_RefreshAliasesKey)
	
        Bool Continue = true
		
        If (conflictControl != "")
		
            String ResetAliasesKeyMsg
			
            If (conflictName != "")
			
                ResetAliasesKeyMsg = "This key is already mapped to:\n\"" + conflictControl + "\"\n(" + conflictName + ")\n\nAre you sure you want to continue?"
            
			Else
            
				ResetAliasesKeyMsg = "This key is already mapped to:\n\"" + conflictControl + "\"\n\nAre you sure you want to continue?"
            
			EndIf

            Continue = ShowMessage(ResetAliasesKeyMsg, true, "$Yes", "$No")
			
        EndIf

        If (Continue)
		
            po3_RUNE_RefreshAliasesKey.SetValue(keyCode as float)  
            SetKeymapOptionValue(OID_RefreshAliasesKey, po3_RUNE_RefreshAliasesKey.GetValue() as int)
			
        EndIf
		
    EndIf

EndEvent

;--------------------------------------------------------------

Event OnConfigClose()

	SendModEvent("RCHotKeyChange")
	
EndEvent

;-------------------------------------------------------------------------------------------

event OnOptionSelect(int option)

	if (option == OID_AllowNPCCast)
		aVal = !aVal
       	SetToggleOptionValue(OID_AllowNPCCast, aVal)
		po3_RUNE_AllowNPCCasting.SetValue((!po3_RUNE_AllowNPCCasting.GetValue() As Bool) As Float)
		
		If po3_RUNE_AllowNPCCasting.GetValue() == 0.0
			po3_RUNE_NPCAliasesQuest.Stop()
		else
			po3_RUNE_NPCAliasesQuest.Start()
		endif
		
	elseif (option == OID_AllowMaster)
	
		iVal = !iVal
       	SetToggleOptionValue(OID_AllowMaster, iVal)
		po3_RUNE_AllowMasterSpells.SetValue((!po3_RUNE_AllowMasterSpells.GetValue() As Bool) As Float)
		
	elseif (option == OID_AllowPCFF)
	
		bVal = !bVal
       	SetToggleOptionValue(OID_AllowPCFF, bVal)
		po3_RUNE_AllowPCFFSpells.SetValue((!po3_RUNE_AllowPCFFSpells.GetValue() As Bool) As Float)
		
	elseif (option == OID_AllowPCConc)
	
		cVal = !cVal
       	SetToggleOptionValue(OID_AllowPCConc, cVal)
		po3_RUNE_AllowPCConcSpells.SetValue((!po3_RUNE_AllowPCConcSpells.GetValue() As Bool) As Float)
		
	elseif (option == OID_AllowPCScrolls)
	
		hVal = !hVal
       	SetToggleOptionValue(OID_AllowPCScrolls, hVal)
		po3_RUNE_AllowPCScrolls.SetValue((!po3_RUNE_AllowPCScrolls.GetValue() As Bool) As Float)
		
	elseif (option == OID_AllowNPCFF)
	
		dVal = !dVal
       	SetToggleOptionValue(OID_AllowNPCFF, dVal)
		po3_RUNE_AllowNPCFFSpells.SetValue((!po3_RUNE_AllowNPCFFSpells.GetValue() As Bool) As Float)
		
	elseif (option == OID_AllowNPCConc)
	
		eVal = !eVal
       	SetToggleOptionValue(OID_AllowNPCConc, eVal)
		po3_RUNE_AllowNPCConcSpells.SetValue((!po3_RUNE_AllowNPCConcSpells.GetValue() As Bool) As Float)
		
	elseif (option == OID_Patch)
	
		fVal = !fVal
       	SetToggleOptionValue(OID_Patch, fVal)
		po3_RUNE_AllowMagAnimPatch.SetValue((!po3_RUNE_AllowMagAnimPatch.GetValue() As Bool) As Float)
		
	elseif (option == OID_NPCPatch)
	
		gVal = !gVal
       	SetToggleOptionValue(OID_NPCPatch, gVal)
		po3_RUNE_AllowNPCMagAnimPatch.SetValue((!po3_RUNE_AllowNPCMagAnimPatch.GetValue() As Bool) As Float)
		
	elseif (option == OID_ClearSpells)  
	
		Int iElement = SpellArray.Length
		While iElement
			iElement -= 1
			PlayerRef.RemoveSpell(SpellArray[iElement])
		EndWhile
		
	elseif (option == OID_ResetQuest)  
	
		Debug.Trace("Strange Runes - Resetting quests")
		
		po3_RUNE_PlayerQuest.Stop()
		po3_RUNE_NPCAliasesQuest.Stop()
		Utility.Wait(0.5)
		po3_RUNE_NPCAliasesQuest.Start()
		po3_RUNE_PlayerQuest.Start()
		
		If PlayerRef.HasSpell(po3_RUNE_DetectCastAbility)
			Debug.Trace("Strange Runes - Player spell cast detection is already active")
		else
			Debug.Trace("Strange Runes - Player spell cast detection is missing or doesn't exist")
			PlayerRef.AddSpell(po3_RUNE_DetectCastAbility, false)
			Debug.Trace("Strange Runes - Player spell cast detection has been added")
		endif
		
		Debug.Trace("Strange Runes - Reset completed")
		Debug.Notification("Strange Runes - Reset completed")
		
		
	elseif (option == OID_WardPatch)
	
		mVal = !mVal
       	SetToggleOptionValue(OID_WardPatch, mVal)
		po3_RUNE_AllowModdedWards.SetValue((!po3_RUNE_AllowModdedWards.GetValue() As Bool) As Float)
		
	elseif (option == OID_WardTypeVanilla)
	
		jVal = !jVal
		SetToggleOptionValue(OID_WardTypeVanilla, jVal)
		
		If jVal == true
			po3_RUNE_WardType.SetValue(0.0)
			SetWardSpellArt(VanillaRune, VanillaRuneCastingArt, MagicLightWardHand01, 1)
			kVal = false
			lVal = false
			SetToggleOptionValue(OID_WardTypeDefault, kVal)
			SetToggleOptionValue(OID_WardTypeStrange, lVal)
			SetOptionFlags(OID_WardTypeVanilla, OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeDefault,OPTION_FLAG_DISABLED)
			SetOptionFlags(OID_WardTypeStrange,OPTION_FLAG_DISABLED)
		elseif jVal == false
			po3_RUNE_WardType.SetValue(0.0)
			SetWardSpellArt(VanillaRune, VanillaRuneCastingArt, MagicLightWardHand01, 1)
			SetOptionFlags(OID_WardTypeVanilla, OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeDefault,OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeStrange,OPTION_FLAG_NONE)
		endif
		
	elseif (option == OID_WardTypeDefault)
	
		kVal = !kVal
		SetToggleOptionValue(OID_WardTypeDefault, kVal)
		
		If kVal == true
			po3_RUNE_WardType.SetValue(1.0)
			SetWardSpellArt(DefaultRune, VanillaRuneCastingArt, MagicLightWardHand01, 0)
			jVal = false
			lVal = false
			SetToggleOptionValue(OID_WardTypeVanilla, jVal)
			SetToggleOptionValue(OID_WardTypeStrange, lVal)
			SetOptionFlags(OID_WardTypeVanilla, OPTION_FLAG_DISABLED)
			SetOptionFlags(OID_WardTypeDefault,OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeStrange,OPTION_FLAG_DISABLED)
		elseif kVal == false
			po3_RUNE_WardType.SetValue(0.0)
			SetWardSpellArt(VanillaRune, VanillaRuneCastingArt, MagicLightWardHand01, 1)
			SetOptionFlags(OID_WardTypeVanilla, OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeDefault,OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeStrange,OPTION_FLAG_NONE)
		endif
		
	elseif (option == OID_WardTypeStrange)
	
		lVal = !lVal
		SetToggleOptionValue(OID_WardTypeStrange, lVal)
		
		If lVal == true
			po3_RUNE_WardType.SetValue(2.0)
			SetWardSpellArt(StrangeRune, StrangeRuneCastingArt, MagicLightFireInHand, 0)
			jVal = false
			kVal = false
			SetToggleOptionValue(OID_WardTypeVanilla, jVal)
			SetToggleOptionValue(OID_WardTypeDefault, kVal)
			SetOptionFlags(OID_WardTypeVanilla, OPTION_FLAG_DISABLED)
			SetOptionFlags(OID_WardTypeDefault, OPTION_FLAG_DISABLED)
			SetOptionFlags(OID_WardTypeStrange,OPTION_FLAG_NONE)
		elseif lVal == false
			po3_RUNE_WardType.SetValue(0.0)
			SetWardSpellArt(VanillaRune, VanillaRuneCastingArt, MagicLightWardHand01, 1)
			SetOptionFlags(OID_WardTypeVanilla, OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeDefault,OPTION_FLAG_NONE)
			SetOptionFlags(OID_WardTypeStrange,OPTION_FLAG_NONE)
		endif
		
	elseif (option == OID_AllowStats)
		nVal = !nVal
       	SetToggleOptionValue(OID_AllowStats, nVal)
		po3_RUNE_AllowStats.SetValue((!po3_RUNE_AllowStats.GetValue() As Bool) As Float)
		
		if po3_RUNE_AllowStats.GetValue() != 0.0
			Debug.Trace("Strange Runes - stats enabled")
			FillNames()
			GetNPCNames()
		endif
		
	elseif (option == OID_DisableNotifications)
		oVal = !oVal
       	SetToggleOptionValue(OID_DisableNotifications, oVal)
		po3_RUNE_DisableNotifications.SetValue((!po3_RUNE_DisableNotifications.GetValue() As Bool) As Float)
		
	elseif (option == OID_ENBLightPatch)
		pVal = !pVal
       	SetToggleOptionValue(OID_ENBLightPatch, pVal)
		po3_RUNE_AllowENBLights.SetValue((!po3_RUNE_AllowENBLights.GetValue() As Bool) As Float)
		SetOptionFlags(OID_SetLightFade, OPTION_FLAG_DISABLED)
		SetOptionFlags(OID_SetWardLightFade, OPTION_FLAG_DISABLED)
		
	elseif (option == OID_AllowSneakingLights)
		sVal = !sVal
       	SetToggleOptionValue(OID_AllowSneakingLights, sVal)
		po3_RUNE_AllowSneakingLights.SetValue((!po3_RUNE_AllowSneakingLights.GetValue() As Bool) As Float)
	
	elseif (option == OID_EnableRuneShadowCasting)
		qVal = !qVal
       	SetToggleOptionValue(OID_EnableRuneShadowCasting, qVal)
		po3_RUNE_AllowRuneShadows.SetValue((!po3_RUNE_AllowRuneShadows.GetValue() As Bool) As Float)
		int iLights = runeLights.Length
		while iLights
			iLights -= 1
			if qVal
				SetLightType(runeLights[iLights], 3) ;omni shadow
			else
				SetLightType(runeLights[iLights], 2) ;omni
			endif
		endWhile
	
	elseif (option == OID_EnableWardShadowCasting)
		rVal = !rVal
       	SetToggleOptionValue(OID_EnableWardShadowCasting, rVal)
		po3_RUNE_AllowWardShadows.SetValue((!po3_RUNE_AllowWardShadows.GetValue() As Bool) As Float)
		int iWardLights = runeWardLights.Length
		while iWardLights
			iWardLights -= 1
			if rVal
				SetLightType(runeWardLights[iWardLights], 3) ;omni shadow
			else
				SetLightType(runeWardLights[iWardLights], 2) ;omni
			endif
		endWhile
	
	elseif (option == OID_EnableRitualShadowCasting)
		tVal = !tVal
       	SetToggleOptionValue(OID_EnableRitualShadowCasting, tVal)
		po3_RUNE_AllowRitualShadows.SetValue((!po3_RUNE_AllowRitualShadows.GetValue() As Bool) As Float)
		int iRitualLights = runeRitualLights.Length
		while iRitualLights
			iRitualLights -= 1
			if tVal
				SetLightType(runeRitualLights[iRitualLights], 3) ;omni shadow
			else
				SetLightType(runeRitualLights[iRitualLights], 2) ;omni
			endif
		endWhile
	endif

endEvent

;-----------------------------------------------------------------------------------------------

event OnOptionMenuOpen(int option)

	if (option == OID_NPCList)
		SetMenuDialogOptions(npcNames)
		SetMenuDialogStartIndex(npcIndex)
		SetMenuDialogDefaultIndex(0)
	endIf
	
endEvent

;----------------EVENT ONOPTIONSELECT()-----------------------------------------------

Event OnOptionSliderOpen(int option)

	if (option == OID_SetLightRadius)
        SetSliderDialogStartValue(po3_RUNE_LightRadius.GetValue())
        SetSliderDialogDefaultValue(OID_LightRadius)
        SetSliderDialogRange(default_rMinValue, default_rMaxValue)
        SetSliderDialogInterval(default_rInterval)
	elseif (option == OID_SetWardLightRadius)
        SetSliderDialogStartValue(po3_RUNE_WardLightRadius.GetValue())
        SetSliderDialogDefaultValue(OID_WardLightRadius)
        SetSliderDialogRange(default_rMinValue, default_rMaxValue)
        SetSliderDialogInterval(default_rInterval)
	elseif (option == OID_SetRitualLightRadius)
        SetSliderDialogStartValue(po3_RUNE_RitualLightRadius.GetValue())
        SetSliderDialogDefaultValue(OID_RitualLightRadius)
        SetSliderDialogRange(default_rMinValue, default_rMaxValue)
        SetSliderDialogInterval(default_rInterval)
	elseif (option == OID_SetLightFade)
        SetSliderDialogStartValue(po3_RUNE_LightFade.GetValue())
        SetSliderDialogDefaultValue(OID_LightFade)
        SetSliderDialogRange(default_fMinValue, default_fMaxValue)
        SetSliderDialogInterval(default_fInterval)
	elseif (option == OID_SetWardLightFade)
        SetSliderDialogStartValue(po3_RUNE_WardLightFade.GetValue())
        SetSliderDialogDefaultValue(OID_WardLightFade)
        SetSliderDialogRange(default_fMinValue, default_fMaxValue)
        SetSliderDialogInterval(default_fInterval)
	elseif (option == OID_SetRitualLightFade)
        SetSliderDialogStartValue(po3_RUNE_RitualLightFade.GetValue())
        SetSliderDialogDefaultValue(OID_RitualLightFade)
        SetSliderDialogRange(default_fMinValue, default_fMaxValue)
        SetSliderDialogInterval(default_fInterval)
	endif

endEvent

;------------------------------------------------------------------------------------------------------

event OnOptionSliderAccept(int option, float value)

    if (option == OID_SetLightRadius)
		int iLights = runeLights.Length
		while iLights
			iLights -= 1
			SetLightRadius(runeLights[iLights], value)
		endWhile
		po3_RUNE_LightRadius.SetValue(Value)
        SetSliderOptionValue(OID_SetLightRadius, po3_RUNE_LightRadius.GetValue(), "{0} units")

    elseif (option == OID_SetWardLightRadius)
		int iWardLights = runeWardLights.Length
		while iWardLights
			iWardLights -= 1
			SetLightRadius(runeWardLights[iWardLights], value)
		endWhile
		po3_RUNE_WardLightRadius.SetValue(Value)
        SetSliderOptionValue(OID_SetWardLightRadius, po3_RUNE_WardLightRadius.GetValue(), "{0} units")
		
	elseif (option == OID_SetRitualLightRadius)
		int iRitualLights = runeRitualLights.Length
		while iRitualLights
			iRitualLights -= 1
			SetLightRadius(runeRitualLights[iRitualLights], value)
		endWhile
		po3_RUNE_RitualLightRadius.SetValue(Value)
        SetSliderOptionValue(OID_SetRitualLightRadius, po3_RUNE_RitualLightRadius.GetValue(), "{0} units")

    elseif (option == OID_SetLightFade)
		int iLights = runeLights.Length
		while iLights
			iLights -= 1
			SetLightFade(runeLights[iLights], value)
		endWhile
		po3_RUNE_LightFade.SetValue(Value)
        SetSliderOptionValue(OID_SetLightFade, po3_RUNE_LightFade.GetValue(), "{2}")

    elseif (option == OID_SetWardLightFade)
		int iWardLights = runeWardLights.Length
		while iWardLights
			iWardLights -= 1
			SetLightFade(runeWardLights[iWardLights], value)
		endWhile
		po3_RUNE_WardLightFade.SetValue(Value)
        SetSliderOptionValue(OID_SetWardLightFade, po3_RUNE_WardLightFade.GetValue(), "{2}")
		
	elseif (option == OID_SetRitualLightFade)
		int iRitualLights = runeRitualLights.Length
		while iRitualLights
			iRitualLights -= 1
			SetLightFade(runeRitualLights[iRitualLights], value)
		endWhile
		po3_RUNE_RitualLightFade.SetValue(Value)
        SetSliderOptionValue(OID_SetRitualLightFade, po3_RUNE_RitualLightFade.GetValue(), "{2}")

    endif
	
endEvent

;-----------------------------------------------------------------------------------------------

Function GetNPCNames()

	;---------------------VARIABLES------------------------------

	npcCount = 0
	int instances = 0
	
	npcNames = new String [75]

	string fullName
	
	;------------------------------------------------------------
	
	debug.trace("Strange Runes - MCM alias trace started")
	
	int npcIDX = npcTempNames.Length
	
	While npcIDX > 0
		npcIDX -= 1
		if npcTempNames[npcIDX] != ""
			string nName = npcTempNames[npcIDX]
			instances = ArrayStringCount(nName, npcTempNames)
			if instances > 1
				fullName =  instances + " " + nName + "(s)"
				if npcNames.Find(fullName) == -1
					AddStringToArray(fullName, npcNames)
				endif
			else
				AddStringToArray(nName, npcNames)
			endif
			npcCount += 1
		endif
	endWhile
	
	npcNames = SortArrayString(npcNames)
	
	po3_RUNE_NPCCount.SetValue(npcCount)
	
	debug.trace("Strange Runes - MCM alias trace finished for " + npcCount + " NPCs")
	
EndFunction	

;--------------------------------------------------------------------------------------------------

Function FillNames()

	int idx  = po3_RUNE_NPCAliasesQuest.GetNumAliases()
	npcTempNames = new String [75]
	
	While idx > 0
	
		idx -= 1	
		ReferenceAlias nthAlias = po3_RUNE_NPCAliasesQuest.GetNthAlias(idx) as ReferenceAlias
		If (nthAlias.GetReference() as Actor) 
			Actor npc = nthAlias.GetReference() as Actor
			npcName = npc.GetLeveledActorBase().GetName()
			AddStringToArray(npcName, npcTempNames)
		endif
		
	endWhile
	
EndFunction	

;-----------------------------------------------------------------------------------------------

Function SetWardSpellArt(Art WardHitArt, Art WardCastArt, Light WardLight, int VanillaState)

	WardConcSelf0.SetCastingArt(WardCastArt)
	WardConcSelf25.SetCastingArt(WardCastArt)
	WardConcSelf50.SetCastingArt(WardCastArt)


	WardConcSelf0.SetHitEffectArt(WardHitArt)
	WardConcSelf25.SetHitEffectArt(WardHitArt)
	WardConcSelf50.SetHitEffectArt(WardHitArt)

	
	WardConcSelf0.SetLight(WardLight)
	WardConcSelf25.SetLight(WardLight)
	WardConcSelf50.SetLight(WardLight)

		
	If VanillaState ==  0
		ShieldConcSelf.SetHitEffectArt(NONE)
		ShieldConcSelf.SetCastingArt(WardCastArt)
		ShieldConcSelf.SetLight(WardLight)
	elseif VanillaState ==  1
		ShieldConcSelf.SetHitEffectArt(WardHitArt)
		ShieldConcSelf.SetCastingArt(WardCastArt)
		ShieldConcSelf.SetLight(WardLight)
	endif
	
	;If po3_RUNE_AllowModdedWards.GetValue() == 1.0
	
	;endif
	
	;----------added for Wards Functionalities Extended patch----------
	ImWaWardConcSelf75.SetCastingArt(WardCastArt)
	ImWaWardConcSelf100Reflective.SetCastingArt(WardCastArt)
	ImWaShieldSelfReflective.SetCastingArt(WardCastArt)
	ImWaWardSelf100.SetCastingArt(WardCastArt)

	
	ImWaWardConcSelf75.SetHitEffectArt(WardHitArt)
	ImWaWardConcSelf100Reflective.SetHitEffectArt(WardHitArt)
	ImWaShieldSelfReflective.SetHitEffectArt(WardHitArt)
	ImWaWardSelf100.SetHitEffectArt(WardHitArt)
	
	If po3_RUNE_WardType.GetValue() == 1.0
		ImWaWardSelf100R.SetHitEffectArt(po3_RUNE_WardDefaultRuneR.GetHitEffectArt())
		ImWaWardSelf100L.SetHitEffectArt(po3_RUNE_WardDefaultRuneL.GetHitEffectArt())
		ImWaWardSelf100B.SetHitEffectArt(po3_RUNE_WardDefaultRuneB.GetHitEffectArt())
	ElseIf po3_RUNE_WardType.GetValue() == 2.0
		ImWaWardSelf100R.SetHitEffectArt(po3_RUNE_WardStrangeRuneR.GetHitEffectArt())
		ImWaWardSelf100L.SetHitEffectArt(po3_RUNE_WardStrangeRuneL.GetHitEffectArt())
		ImWaWardSelf100B.SetHitEffectArt(po3_RUNE_WardStrangeRuneB.GetHitEffectArt())
	Else
		ImWaWardSelf100R.SetHitEffectArt(po3_RUNE_WardVanillaRuneR.GetHitEffectArt())
		ImWaWardSelf100L.SetHitEffectArt(po3_RUNE_WardVanillaRuneL.GetHitEffectArt())
		ImWaWardSelf100B.SetHitEffectArt(po3_RUNE_WardVanillaRuneB.GetHitEffectArt())
	EndIf
	
	ImWaWardConcSelf75.SetLight(WardLight)
	ImWaWardConcSelf100Reflective.SetLight(WardLight)
	ImWaShieldSelfReflective.SetLight(WardLight)
	ImWaWardSelf100.SetLight(WardLight)
	;--------------------------------------------------------------------
	
EndFunction	

;--------------------------------------------------------------------------------------------------

bool function ArrayAddForm(String[] myArray, String myForm)

	;-----------\
	;Description \	Author: Chesko
	;----------------------------------------------------------------
	;Adds a form to the first available element in the array.
	
	;-------------\
	;Return Values \
	;----------------------------------------------------------------
	;		false		=		Error (array full)
	;		true		=		Success
			
	int i = 0
	;notification("myArray.Length = " + myArray.Length)
	while i < myArray.Length
		if myArray[i] == ""
			myArray[i] = myForm
			;notification("Adding " + myForm + " to the array.")
			return true
		else
			i += 1
		endif
	endWhile
	
	return false

endFunction

;-------------------------------------------------------------------------------------------------

string Function Round(float number, int precision)
    string result = number as int
    number -= number as int
    if precision > 0
        result += "."
    endif
    while precision > 0
        number *= 10
        precision -= 1
        if precision == 0
            number += 0.5
        endif
        result += number as int
        number -= number as int
    endwhile
    return result
EndFunction

